/*
 * alibavaService.h
 *
 *  Created on: Jul 13, 2012
 *      Author: lacasta
 */

#ifndef ALIBAVASERVICE_H_
#define ALIBAVASERVICE_H_
#include <map>
#include <string>
#include <soapalibavaSOAPService.h>
class alibavaService : public alibavaSOAPService
{
    private:
        std::map<int, std::string> hstnames;


        void init_service();
        void setup_names();
        void set_up_run(ns1__DAQParam *daqParam);
    public:
        alibavaService();
        alibavaService(const struct soap &_soap);
        virtual ~alibavaService();

        alibavaSOAPService *copy();

        /// Web service operation 'getStatus' (returns error code or SOAP_OK)
        int getStatus(int getStatusRequest, struct ns1__getStatusResponse &_param_1) ;

        /// Web service operation 'getMonitorData' (returns error code or SOAP_OK)
        int getMonitorData(int getMonitorDataRequest, struct ns1__getMonitorDataResponse &_param_2)  ;

        /// Web service operation 'getEventData' (returns error code or SOAP_OK)
        int getEventData(int getEventDataRequest, struct ns1__getEventDataResponse &_param_3);

        /// Web service operation 'getEventHeaders' (returns error code or SOAP_OK)
        int getEventHeaders(int getEventHeadersRequest, struct ns1__getEventHeadersResponse &_param_4);

        int startRun(ns1__DAQParam *runType, struct ns1__startRunResponse &_param_5);
        int startRunAsync(ns1__DAQParam *daqParam);
        int stopRun(int stopRunRequest, struct ns1__stopRunResponse &_param_6);
        int getRunData(int getRunDataParam, struct ns1__getRunDataResponse &_param_7);

        int Reset(int resetParam);

        int setDataFile(std::string setDataFileRequest, struct ns1__setDataFileResponse &_param_7);

        int setParameter(ns1__ParValue *setParameterRequest, struct ns1__setParameterResponse &_param_8);
        int getMask(int getMaskRequest, struct ns1__getMaskResponse &_param_10);
        int getHistogram(ns1__ParValue *histogramName, struct ns1__getHistogramResponse &_param_11);
};

#endif /* ALIBAVASERVICE_H_ */
