/*
 * PluginConfig.h
 *
 *  Created on: Jul 23, 2009
 *      Author: lacasta
 */

#ifndef PLUGINCONFIG_H_
#define PLUGINCONFIG_H_

#include <string>
#include <gmodule.h>
#include <ConfigFile.h>
#include <Plugin.h>

struct PluginPriv;

class PluginConfig : public ConfigFile
{
    private:
        std::string _lib;
        std::string _hook;
        std::string _lang;
        std::string _path;

        PluginPriv *priv;

        bool _active;

        std::string find_file(const std::string &fnam);
        void cpy(const PluginConfig &);
        void init();
        void load_lib();
        void unload_lib();
    public:
        PluginConfig();
        PluginConfig(const std::string &lib, const std::string &hook, const std::string &lang);
        PluginConfig(const PluginConfig &P);
        PluginConfig &operator=(const PluginConfig &P)
        {
            if (this!=&P)
                cpy(P);

            return *this;
        }
        virtual ~PluginConfig();

        const std::string lib() const { return _lib; }
        const std::string hook() const { return _hook; }
        const std::string lang() const { return _lang; }
        const std::string path() const  { return _path; }
        char *lib_path();

        void lib(std::string x) { _lib = x; }
        void path(std::string x) { _path = x; }
        void lang(std::string x) { _lang = x; }
        void hook(std::string x) { _hook = x; }

        void load_data();
        void save_data();

        bool active() const { return _active; }
        void active(const bool xxx);
        Plugin *plugin();
};

#endif /* PLUGINCONFIG_H_ */
