#include <unistd.h>
#include "USBpatch.h"

#if defined(USE_USB_PATCH)
#define CHUNK_SIZE 0x1000
int read_from_file(int fd, void *buf, int size)
{
    // linux kernels below 2.6.26 have a problem and we may need
    // to read in small chuncks (<20kb)
    int rc = 0;
    int left = size;
    char *obuf=(char *)buf;
    while (left>0)
    {
        int ir = read(fd, obuf, left > CHUNK_SIZE ? CHUNK_SIZE : left);
        if (ir<=0)
        {
            if (rc==0)
                rc = ir;

            break;
        }
        else
        {
            left -= ir;
            obuf += ir;
            rc += ir;
        }
    }
    return rc;
}

#endif
int read_from_port(int fd, void *buf, int size)
{
    int rc, i,nr=size/sizeof(char);
    char *dest = (char *)buf;
    for (i=0;i<nr;i++)
    {
        rc = read(fd, dest, sizeof(char));
        if (rc < 0)
            break;
        dest++;
    }
    return dest-(char *)buf;

    // If we do it otherwise, it gets stuck in the call to read... Do not know why...
//    return ::read(fd, buf, size);
}
