#include <iostream>
#include <getopt.h>
#include <string>
#include <vector>
#include <fstream>
#include <ctime>
#include "AsciiDataFile.h"

int main(int argc, char **argv)
{
    char c;
    int this_option_optind;
    int option_index;
    static struct option long_options[] =  {
        { "out", 1, 0, 'o' }, // Output file
        { "help", 0, 0, 'h' },
        { 0, 0, 0, 0 }
     };

    /*
     * Get the program name
     */
    std::string prgnam = argv[0];
    std::string::size_type jpos = prgnam.rfind('/');
    if (jpos != prgnam.npos)
        prgnam = prgnam.substr(jpos + 1);

    /*
     * Get the list of input files and the name of the output file
     */

    std::string out_file = "alibava_merged.data";
    std::vector<std::string> input_files;
    while (1)
    {
        this_option_optind = optind ? optind : 1;
        option_index = 0;
        c = getopt_long(argc, argv, ":n:p:g:m:ho:e:", long_options, &option_index);
        if (c == -1)
            break;
        switch (c)
        {
            case 0:
                break;
            case 'o':
                out_file = optarg;
                break;
            case 'h':
                std::cout << "Usage: " << prgnam << " [options] " << std::endl
                        << "Posible options: " << std::endl;
                for (int i = 0; long_options[i].name; i++)
                    std::cout << "\t--" << long_options[i].name << " , -"
                            << (char) long_options[i].val << std::endl;

                return 1;
                break;
            case '?':
                break;
            default:
                std::cout << prgnam << " -> " << (char) optopt << " " << argv[optind]
                        << std::endl;
                std::cout << "Ughhhhh !!!!" << std::endl;
                return 1;
                break;
        }
    }
    while (optind < argc)
        input_files.push_back(argv[optind++]);

    /*
     * Open the output file
     */
    std::ofstream outf(out_file.c_str());

    int _type;
    time_t _t0;
    EventData data;
    double _ped[256];
    double _noise[256];
    bool first_file = true;

    std::vector<std::string>::iterator ip;
    for (ip = input_files.begin(); ip != input_files.end(); ip++)
    {
        std::ifstream ifile(ip->c_str());
        if (!ifile)
        {
            std::cout << "Could not open " << *ip << std::endl;
            continue;
        }
        /*
         * read the header
         */
        std::string header;
        unsigned int ic, lheader;
        char c;
        ifile.read((char *) &_t0, sizeof(time_t));
        ifile.read((char *) &_type, sizeof(int));
        ifile.read((char *) &lheader, sizeof(unsigned int));
        for (ic = 0; ic < lheader; ic++)
        {
            ifile.read(&c, sizeof(char));
            header.append(1, c);
        }
        ifile.read((char *) _ped, 256 * sizeof(double));
        ifile.read((char *) _noise, 256 * sizeof(double));
        if (first_file)
        {
            outf.write((const char *) &_t0, sizeof(time_t));
            outf.write((const char *) &_type, sizeof(int));
            outf.write((const char *) &lheader, sizeof(unsigned int));
            outf.write(header.c_str(), lheader);
            outf.write((const char *) _ped, 256 * sizeof(double));
            outf.write((const char *) _noise, 256 * sizeof(double));
            first_file = false;
        }

        while (ifile)
        {
            ifile.read((char *) &data, sizeof(EventData));
            if (ifile.eof())
                break;

            outf.write((char *) &data, sizeof(EventData));
        }
        ifile.close();
    }

    outf.close();
}
